import json, random, math, datetime as d

class Exerciser:

    ex_dict = {}

    def __init__(self, keys:list, filename = "bank.json"):
        # при создании объекта упражнениа вызываются метод set_ket_list
        self.set_ex_list(keys, filename)


    def set_ex_list(self, keys:list, filename:str):
        # устнавливается массив ключей
        # открытие файла из переменной filename
        with open(filename, 'r', encoding="utf-8") as file:
            # считывание json из этого файла в переменную mas
            mas = json.load(file)
        # выбор ключа (имя блока упражнений) и сам блок упражнений
        for key, value in mas.items():
            # если имя есть в списке нужных имен, то добавляем блок упражнений с соотв. именем в словарь ex_dict
            # который находится в памяти объекта Exerciser
            if key in keys:
                self.ex_dict.update({key:value})
            else:
                #вызов исключения (ошибки)
                Exception

    def get_ex(self, key:str, level = 1, count = 1):
        # получаем упражнения, на вход подается имя комплекта упражнений, уровень сложности и их число
        # = 1 - это значения по умолчанию, если их не передать, то бубдут использоать эти значения
        # создаем временную копию блока упражнений, того самого блока, какой нужен, key
        temp_ex_list = self.ex_dict[key]
        # заготовка, пустой массив с упражнениями
        exercises = []
        # пока число упражнений, которые нужно добавить, не 0, то есть, пока не добавим нужно количество
        while count>0:
            # Нужно набрать всего count упражнений
            # функций sample позвояляет получить step случайных элементов из массива
            # но step должна быть меньше длины массива. Поэтому мы берем min. Если count вдруг больше, чем
            # количество упражнений в этой группе, мы берем step равным этому самому количеству
            step = min(count, len(temp_ex_list))
            # и заносим в массив упражнений всё, что выбрали
            exercises.extend(random.sample(temp_ex_list, step))
            # если count было меньше числа упражнений, то на 2 строки выше мы выберем его, и тут получится 0
            # если нет, то он просто станет меньше, и мы еще раз выполним этот блок. Пока не будет 0
            count -= step
        # заготовка, пустой массив результат, которые вернем
        res = []
        # для каждого упражнения, из тех, что мы выбрали выше
        for ex in exercises:
            # получаем подходы и повторения approach and count, обращаясь к методу get_value класса Exerciser
            appr_x_count = self.get_value(ex, level)
            # в массив результата заносим данное упражнение, как словарь с тремя ключами
            res.append({"title":ex['title'], "value":appr_x_count, "injures":ex['injures']})
        # возвращаем массив со словарями упражнений, который получили выше
        return res

    @staticmethod
    def get_value(ex, level):
        # получаем подходы и повторения.
        # получаем общее число повторений упражнения, за все подходы разом
        # Берем базовое число и у множаем на уровень сложности
        overall_count = ex['base_count']*level
        # изменяем его слегонца. распределение гаусса от 0 с сигмой overall_count*0.2 дает на выходе что-то вроде
        # "+- где-то 20% от значения"
        overall_count += random.gauss(0,overall_count*0.2)
        # параметр ратио показывает насколько крупными могут быть подходы
        # для приседаний норма делать подходы по 30-50 разом, для подтягиваний - по 3-10, не более
        # степень 1/2 - это квадратный корень
        # количесто подходов берется равным квадратноу корню из частного общего числа повторов и параметра ратио
        approach = (overall_count / ex['ratio'])**0.5
        # число повторов в подходе -  это общее число повтором, деленое на количество подходов
        cur_count = overall_count / approach
        # функция ceil библиотеки math округляет до целого в бОльшую сторону
        # фрагмент с /5 и *5 позволяет округлить число повторений в подходах до кратного 5
        final_cur_count = math.ceil(cur_count/5)*5
        appr_x_count = f"{math.ceil(approach)}x{final_cur_count}"
        # получаем число подходов и повторений, довольно случайное, но в разумной дельте от заданного изначально
        # причем толкьо 2х10, 3х15, а не 3х13, 2х11. Чтоб красиво было
        return appr_x_count


class Sheduler:

    def __init__(self, mode, data, level, keys, count_per_day,date_from, date_to, pulse_before, pulse_after):
        # всё, что делается через self, это обращение к полям объекта.
        # тут мы создем у Sheduler новое поле, в которое кладем объект класса Exerciser, который создается тут же,
        # когда мы передаем в конструктор парамтер keys (он ему нужен, чтоб создаться)
        self.exerciser = Exerciser(keys)
        # получем дату, от которой и до которой нужен дневник, создаем объект даты из строки с датой по формату
        date_from = d.datetime.strptime(date_from, "%d.%m.%Y")
        date_to = d.datetime.strptime(date_to, "%d.%m.%Y")
        # вызваем по очереди два метода
        self.set_base_shed(date_from, date_to, mode, data)
        self.fulfill_shed(level, keys, count_per_day, pulse_before, pulse_after)


    def set_base_shed(self, date_from, date_to, mode, data):
        # разница между датами в днях
        period = (date_to - date_from).days
        if mode == 0:
            # занятия каждые data дней
            # в data тогда лежит число, и каждые data дней будет занятие
            # range (от ,до, шаг), если от 0 до 50 с шагом 10, то будет 0, 10, 20, 30, 40
            # d - это сокращение для datetime, можно посмотреть в самом верху
            # чисто интуитивно, timedelta - это дельта времен расстояние во времени.
            # days=x - отрезок времени в х дней.
            # у нас есть период дневника (от первого до последнего дня)
            # поэтому мы к первому дню (date_from) прибавляем по х дней, при х от 0 до периода дневника, с шагом data
            # в data у нас "раз во сколько дней занятие"
            date_gen = [date_from + d.timedelta(days=x) for x in range(0, period, data)]
        elif mode == 1:
            # занятия в дни недели data
            # тут мы делаем range без шага data, то есть, берем всем дни недели разом
            temp_date_gen = [date_from + d.timedelta(days=x) for x in range(0, period)]
            # и сразу перебираем всё, что сделали, и выбираем только те дни, которые указаны в data
            # day.weekday() - это номер дня недели для каждого дня
            date_gen = [day for day in temp_date_gen if day.weekday() in data] # sorry for this
        # у объекта завели поле shed, положили туда пустой массив
        self.shed = []
        # для каждого дня расписания, которые мы нашли, мы сохраняем в shed словарь, в котором лежит
        # один ключ date, по которому лежит сам объект даты - конкретный день
        for day in date_gen:
            self.shed.append({"date":day})
        # по итогу получаем в поле shed кучу (массив) словариков, в каждом из которых есть поле date и соотв. объект даты
        # согласно названию метода, set_base_shed, устанавливаем базу расписания. Массив со словараями, в каждом из которы
        #  пока что только день

    def fulfill_shed(self, level, keys, count, pulse_before, pulse_after):
        # заполняем расписание
        # дни у нас от 0 до 6, поэтому 10 заведомо больше любого значения дня недели
        day_before = 10
        key_id = 0
        # keys - это массив с ключами (именами) групп упражнений
        # перемешиваем порядок элементов массива keys
        random.shuffle(keys)
        for i, day in enumerate(self.shed):

            if day['date'].weekday()<= day_before:
                # если weekday меньше, чем у предыдущего, значит мы перешли на новую неделю
                key_id += 1
            # текущий (для этого дня) ключ группы упражнений
            # % - остаток от деления
            # увеличиваем key_id постоянно, и обращаемя в массиве ключе к остатку от деления key_id на длин массва
            # получаем, постоянно ходим от начала до конца массива keys
            # совместно с блоком выше, каждую новую неделю мы занимаемся упражнениями из следующей групппы
            cur_key = keys[key_id % len(keys)]
            # сохраняем day_before дял следующей итерации
            day_before = day['date'].weekday()
            # получаем упражнения, передавая ключ группы, уровень сложности и количество упражнений
            exercises = self.exerciser.get_ex(cur_key, level, count)
            # обращаемся в словарику нужного дня и заносим туда эти упражнения под ключом ex
            self.shed[i].update({"ex":exercises})
            # обявили массив состояний, которые можем получить по итогу дня
            state = []
            # массив  с возможными хорошими состояниями
            good_states = ['Отличное', 'Нормальное', 'удовлетворительное']
            # перебираем все упражнения за этот день, сколько бы их ни было
            for ex in exercises:
                # для КАЖДОГО упражнения заносим в state ВСЕ хорошие состояния
                state.extend(good_states)
                # заносим state все возможные "травмы" (негативные состояния) конкретно этого урпажнения
                state.extend(ex['injures'])
            # по итогу получаем массив с сотояниями. Тянем из него одно случайное
            # чем больше негативных состояний у упражнения, тем больше вероятность, что в итоге состояние
            # будет выбрано негативное
            cur_state = random.choice(state)
            # заносим выбранносе состояник в словарь текущего дня
            self.shed[i].update({"state":cur_state})

            # выбираем случайное настроение и заносив его в словарь текущего дня
            mood = random.choice(["+","-"])
            self.shed[i].update({"mood":mood})
            # заказываем  пульс до упражениня. Берем базовое значение получаем случайное занчене из
            # гауссовского распределения с параметром 3, то есть, в небольшом радиусе от референсного пульса ДО
            p_b = random.gauss(pulse_before,3)
            # заказываем пульс после, получаем его из референсного значения, но с бОльших разбросом возможных занчений
            p_a = random.gauss(pulse_after,10)
            # создаем строку с понятным представлением
            pulse = f"До: {round(p_b)}\nПосле: {round(p_a)}"
            # и вносим ее в словарь текущего дня
            self.shed[i].update({"pulse":pulse})
